import traceback
from typing import Optional

from cpl_core.console import Console

from bot_api.abc.dto_abc import DtoABC
from bot_data.model.auth_role_enum import AuthRoleEnum


class AuthUserDTO(DtoABC):

    def __init__(
            self,
            id: int,
            first_name: str,
            last_name: str,
            email: str,
            password: str,
            confirmation_id: Optional[str],
            auth_role: AuthRoleEnum,
    ):
        DtoABC.__init__(self)

        self._id = id
        self._first_name = first_name
        self._last_name = last_name
        self._email = email
        self._password = password
        self._is_confirmed = confirmation_id is None
        self._auth_role = auth_role

        """
        long Id { get; set; }
        string FirstName { get; set; }
        string LastName { get; set; }
        string EMail { get; set; }
        string Password { get; set; }
        bool IsConfirmed { get; set; }
        AuthRoles AuthRole { get; set; }
        """

    def from_dict(self, values: dict):
        self._id = values['Id']
        self._first_name = values['FirstName']
        self._last_name = values['LastName']
        self._email = values['EMail']
        self._password = values['Password']
        self._is_confirmed = values['IsConfirmed']
        self._auth_role = values['AuthRole']

    def to_dict(self) -> dict:
        return {
            "Id": self._id,
            "FirstName": self._first_name,
            "LastName": self._last_name,
            "EMail": self._email,
            "Password": self._password,
            "IsConfirmed": self._is_confirmed,
            "AuthRole": self._auth_role,
        }
